#pragma once

#include <string.h>
#include <stdlib.h>
#include <assert.h>

#define ASSERT assert
typedef int BOOL;
#define TRUE 1
#define FALSE 0
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef unsigned __int64 QWORD;
//#define CDECL __cdecl   // VC̏ꍇ͂̍s`
#define CDECL           // VCȊȌꍇ͂̍s`邩AKX`

// ReverseEndianŃAZułgꍇ1AgȂꍇ0
#define USE_REVERSEENDIAN_ASSEMBLER 0
#if (USE_REVERSEENDIAN_ASSEMBLER==0)
    void ReverseEndian32(void *dest, const void *src, DWORD len);
    void ReverseEndian64(void *dest, const void *src, DWORD len);
#else
    extern "C" void CDECL ReverseEndian32(void *dest, const void *src, DWORD len);
    extern "C" void CDECL ReverseEndian64(void *dest, const void *src, DWORD len);
#endif

// ROTATE
//#define ROTATE_L32(x,n)     ( _rotl(x,n) )  // _rotl()gꍇ͂D
//#define ROTATE_R32(x,n)     ( _rotr(x,n) )  // _rotr()gꍇ͂D
#define ROTATE_L32(x,n)     ( ((x) << (n)) | ((x) >> (32 - (n))) )  // _rotl()gȂꍇ͂g
#define ROTATE_R32(x,n)     ( ((x) >> (n)) | ((x) << (32 - (n))) )  // _rotr()gȂꍇ͂g


class CMakeHashAlgorithm
{
public:
    CMakeHashAlgorithm();
    ~CMakeHashAlgorithm();

    virtual DWORD GetHashValueSize()=0;
    virtual DWORD GetHashBlockSize()=0;
    virtual void Initialize();
    void ComputeHash(const void *pBuffer, DWORD len);

    void GetHashValue(void *msg_digest);
    void GetHashValueWithoutInitializing(void *msg_digest);
    void GetHashString(char *pStrBuf, BOOL bSmallString);

protected:
    virtual DWORD ComputeHashHelper(const void *pBuffer, DWORD len)=0;
    virtual DWORD ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len)=0;
    virtual void ComputeHashFinalHelper(void *msg_digest)=0;

protected:
    DWORD m_dwRestLen;
    QWORD m_qwSrcLen;
    BYTE m_pRest[512];
};
