;***************************************************************************************************
;
; void MakeMD5Helper_asm(const void *w, void *hash, DWORD len)
;
;***************************************************************************************************

.586
.model flat, c



ROTATE      MACRO   a, s
    IF  (s LT 16)   ;(s<16)
        rol a, s
    ELSE
        ror a, 32-s
    ENDIF
ENDM


ROUND1      MACRO   a, b, c, d, k, s, i
    mov edi, b
    mov esi, b
    and edi, c
    not esi
    and esi, d
    or  edi, esi

    add a, [ebp+k*4]
    lea a, [a+edi+i]
    ROTATE a, s
    add a, b
ENDM


ROUND2      MACRO   a, b, c, d, k, s, i
    mov edi, b
    mov esi, d
    and edi, d
    not esi
    and esi, c
    or  edi, esi

    add a, [ebp+k*4]
    lea a, [a+edi+i]
    ROTATE a, s
    add a, b
ENDM


ROUND3      MACRO   a, b, c, d, k, s, i
    mov esi, [ebp+k*4]
    mov edi, b
    xor edi, c
    xor edi, d

    lea esi, [esi+edi+i]
    add a, esi
    ROTATE a, s
    add a, b
ENDM


ROUND4      MACRO   a, b, c, d, k, s, i
    mov edi, d
    not edi
    or  edi, b
    xor edi, c

    add a, [ebp+k*4]
    lea a, [a+edi+i]
    ROTATE a, s
    add a, b
ENDM



;***************************************************************************************************
; `

; 
w       equ     <esp+24>
hash    equ     <esp+28>

;***************************************************************************************************

.code

MakeMD5Helper_asm      proc

    mov eax, [esp+12]       ; eax <- len
    shr eax, 6
    jnz PRE
    ret


  PRE:
    push ebp
    push ecx
    push esi
    push edi
    push ebx
    shl eax, 6
    mov ebp, [w]
    add eax, ebp
    mov [w], eax
    mov esi, [hash]
    mov eax, [esi]
    mov ebx, [esi+4]
    mov ecx, [esi+8]
    mov edx, [esi+12]


  MAINLOOP:
    ROUND1      eax,ebx,ecx,edx,  0,  7, 0d76aa478h
    ROUND1      edx,eax,ebx,ecx,  1, 12, 0e8c7b756h
    ROUND1      ecx,edx,eax,ebx,  2, 17, 0242070dbh
    ROUND1      ebx,ecx,edx,eax,  3, 22, 0c1bdceeeh
    ROUND1      eax,ebx,ecx,edx,  4,  7, 0f57c0fafh
    ROUND1      edx,eax,ebx,ecx,  5, 12, 04787c62ah
    ROUND1      ecx,edx,eax,ebx,  6, 17, 0a8304613h
    ROUND1      ebx,ecx,edx,eax,  7, 22, 0fd469501h
    ROUND1      eax,ebx,ecx,edx,  8,  7, 0698098d8h
    ROUND1      edx,eax,ebx,ecx,  9, 12, 08b44f7afh
    ROUND1      ecx,edx,eax,ebx, 10, 17, 0ffff5bb1h
    ROUND1      ebx,ecx,edx,eax, 11, 22, 0895cd7beh
    ROUND1      eax,ebx,ecx,edx, 12,  7, 06b901122h
    ROUND1      edx,eax,ebx,ecx, 13, 12, 0fd987193h
    ROUND1      ecx,edx,eax,ebx, 14, 17, 0a679438eh
    ROUND1      ebx,ecx,edx,eax, 15, 22, 049b40821h

    ROUND2      eax,ebx,ecx,edx,  1,  5, 0f61e2562h
    ROUND2      edx,eax,ebx,ecx,  6,  9, 0c040b340h
    ROUND2      ecx,edx,eax,ebx, 11, 14, 0265e5a51h
    ROUND2      ebx,ecx,edx,eax,  0, 20, 0e9b6c7aah
    ROUND2      eax,ebx,ecx,edx,  5,  5, 0d62f105dh
    ROUND2      edx,eax,ebx,ecx, 10,  9, 002441453h
    ROUND2      ecx,edx,eax,ebx, 15, 14, 0d8a1e681h
    ROUND2      ebx,ecx,edx,eax,  4, 20, 0e7d3fbc8h
    ROUND2      eax,ebx,ecx,edx,  9,  5, 021e1cde6h
    ROUND2      edx,eax,ebx,ecx, 14,  9, 0c33707d6h
    ROUND2      ecx,edx,eax,ebx,  3, 14, 0f4d50d87h
    ROUND2      ebx,ecx,edx,eax,  8, 20, 0455a14edh
    ROUND2      eax,ebx,ecx,edx, 13,  5, 0a9e3e905h
    ROUND2      edx,eax,ebx,ecx,  2,  9, 0fcefa3f8h
    ROUND2      ecx,edx,eax,ebx,  7, 14, 0676f02d9h
    ROUND2      ebx,ecx,edx,eax, 12, 20, 08d2a4c8ah

    ROUND3      eax,ebx,ecx,edx,  5,  4, 0fffa3942h
    ROUND3      edx,eax,ebx,ecx,  8, 11, 08771f681h
    ROUND3      ecx,edx,eax,ebx, 11, 16, 06d9d6122h
    ROUND3      ebx,ecx,edx,eax, 14, 23, 0fde5380ch
    ROUND3      eax,ebx,ecx,edx,  1,  4, 0a4beea44h
    ROUND3      edx,eax,ebx,ecx,  4, 11, 04bdecfa9h
    ROUND3      ecx,edx,eax,ebx,  7, 16, 0f6bb4b60h
    ROUND3      ebx,ecx,edx,eax, 10, 23, 0bebfbc70h
    ROUND3      eax,ebx,ecx,edx, 13,  4, 0289b7ec6h
    ROUND3      edx,eax,ebx,ecx,  0, 11, 0eaa127fah
    ROUND3      ecx,edx,eax,ebx,  3, 16, 0d4ef3085h
    ROUND3      ebx,ecx,edx,eax,  6, 23, 004881d05h
    ROUND3      eax,ebx,ecx,edx,  9,  4, 0d9d4d039h
    ROUND3      edx,eax,ebx,ecx, 12, 11, 0e6db99e5h
    ROUND3      ecx,edx,eax,ebx, 15, 16, 01fa27cf8h
    ROUND3      ebx,ecx,edx,eax,  2, 23, 0c4ac5665h

    ROUND4      eax,ebx,ecx,edx,  0,  6, 0f4292244h
    ROUND4      edx,eax,ebx,ecx,  7, 10, 0432aff97h
    ROUND4      ecx,edx,eax,ebx, 14, 15, 0ab9423a7h
    ROUND4      ebx,ecx,edx,eax,  5, 21, 0fc93a039h
    ROUND4      eax,ebx,ecx,edx, 12,  6, 0655b59c3h
    ROUND4      edx,eax,ebx,ecx,  3, 10, 08f0ccc92h
    ROUND4      ecx,edx,eax,ebx, 10, 15, 0ffeff47dh
    ROUND4      ebx,ecx,edx,eax,  1, 21, 085845dd1h
    ROUND4      eax,ebx,ecx,edx,  8,  6, 06fa87e4fh
    ROUND4      edx,eax,ebx,ecx, 15, 10, 0fe2ce6e0h
    ROUND4      ecx,edx,eax,ebx,  6, 15, 0a3014314h
    ROUND4      ebx,ecx,edx,eax, 13, 21, 04e0811a1h
    ROUND4      eax,ebx,ecx,edx,  4,  6, 0f7537e82h
    ROUND4      edx,eax,ebx,ecx, 11, 10, 0bd3af235h
    ROUND4      ecx,edx,eax,ebx,  2, 15, 02ad7d2bbh
    ROUND4      ebx,ecx,edx,eax,  9, 21, 0eb86d391h

    mov esi, [hash]
    add eax, [esi]
    add ebx, [esi+4]
    add ecx, [esi+8]
    add edx, [esi+12]

    mov [esi],    eax
    mov [esi+4],  ebx
    mov [esi+8],  ecx
    mov [esi+12], edx

    add ebp, 64
    cmp ebp, [w]
    jne MAINLOOP

    pop ebx
    pop edi
    pop esi
    pop ecx
    pop ebp
    ret

MakeMD5Helper_asm      endp

end
