// MakeSHA256.h: CMakeSHA256 NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "MakeHashAlgorithm.h"

class CMakeSHA256 : public CMakeHashAlgorithm
{
public:
    CMakeSHA256();
    ~CMakeSHA256();

    virtual DWORD GetHashValueSize() { return 32; }
    virtual DWORD GetHashBlockSize() { return 64; }
    virtual void Initialize();

#ifdef HASH_TEST
    void Test();
#endif

private:
    virtual DWORD ComputeHashHelper(const void *pBuffer, DWORD len)
            { return ComputeHashHelper(pBuffer, m_pHash, len); }
    virtual DWORD ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len);
    virtual void ComputeHashFinalHelper(void *msg_digest);

private:
    DWORD m_pHash[8];
};
